Attribute VB_Name = "LinkFunctions"
'==============    ===============
Option Explicit
Option Private Module

Public Function GetFullPath(ByVal addr$, docpath$) As String
'     
  If Left(addr, 1) = "." Or InStr(addr, "\") + InStr(addr, "/") = 0 Then
    If Not docpath = vbNullString Then
      addr = docpath & "\" & addr
    Else
      GetFullPath = addr
      Exit Function
    End If
  End If
  
  Dim leftSide$
  Do While InStr(addr, "../") <> 0
    leftSide = Left(addr, InStr(addr, "../") - 1)
    leftSide = Left(leftSide, InStrRev(leftSide, "\", Len(leftSide) - 1))
    addr = leftSide & Right(addr, Len(addr) - InStr(addr, "../") - 2)
  Loop
  
  GetFullPath = Replace(addr, "/", "\")
End Function

Public Function ConvertLinkToLocal(ByVal addr$) As String
'    P:\  \\STRG1\...
  ConvertLinkToLocal = addr
  If Left(addr, 3) Like "P:\" Then _
    ConvertLinkToLocal = "\\STRG1\Projects\" & Right(addr, Len(addr) - 3)
  If Left(addr, 3) Like "X:\" Then _
    ConvertLinkToLocal = "\\Server\Exchange\" & Right(addr, Len(addr) - 3)
End Function

Public Function ConvertLinkToURL(ByVal addr$) As String
'    \\STRG1\...  P:\  \\server\...  X:\
  ConvertLinkToURL = addr
  If Left(addr, 17) Like "\\[Ss][Tt][Rr][Gg]1\[Pp]rojects\" Then _
    ConvertLinkToURL = "P:\" & Right(addr, Len(addr) - 17)
  If Left(addr, 18) Like "\\[Ss][Ee][Rr][Vv][Ee][Rr]\[Ee]xchange\" Then _
    ConvertLinkToURL = "X:\" & Right(addr, Len(addr) - 18)
End Function

Public Function SafeGetHLinkAddress(hLink As Hyperlink) As String
'       .  4198
  On Error GoTo PICK_RANGE
  SafeGetHLinkAddress = hLink.Address
  
  Exit Function
PICK_RANGE:
  SafeGetHLinkAddress = hLink.Range.Text
End Function

Public Function IsSamePath(ByVal hLinkText$, ByVal hLinkAddress$, docpath$) As Boolean
  IsSamePath = False
  hLinkText = UCase(ConvertLinkToURL(GetFullPath(hLinkText, docpath)))
  hLinkAddress = UCase(ConvertLinkToURL(GetFullPath(hLinkAddress, docpath)))
  If InStr(hLinkText, hLinkAddress) = 1 And Abs(Len(hLinkText) - Len(hLinkAddress)) <= 1 Then IsSamePath = True
End Function
