Attribute VB_Name = "PublicSubs"
Option Explicit

Public Sub CCM_AddColumnBreak()
  Dim selPar As Word.Range: Set selPar = ActiveDocument.ActiveWindow.Selection.Paragraphs.First.Range
  Call selPar.Collapse(wdCollapseStart)
  Call selPar.InsertBreak(wdColumnBreak)
End Sub

Public Sub CCM_NonBreakPar()
  ActiveDocument.ActiveWindow.Selection.ParagraphFormat.KeepTogether = Not ActiveDocument.ActiveWindow.Selection.ParagraphFormat.KeepTogether
End Sub

Public Sub CCM_WithNext()
  Selection.ParagraphFormat.KeepWithNext = Not Selection.ParagraphFormat.KeepWithNext
End Sub

Public Sub CCM_FieldLowerer()
  Dim tmpRange As Word.Range: Set tmpRange = ActiveDocument.ActiveWindow.Selection.Range.Duplicate
  tmpRange.Start = ActiveDocument.ActiveWindow.Selection.Words.First.Start
  tmpRange.End = ActiveDocument.ActiveWindow.Selection.Words.Last.End
  
  On Error GoTo EXT_SUB
  Dim execField As Word.Field
  For Each execField In tmpRange.Fields
    Call bilCrossRef(execField)
  Next execField
EXT_SUB:
End Sub

Public Sub CCM_MakeUniqueBM()
'     
  Dim contextMap As New Collection
  
  Dim pref$: pref = "t" & Format(Date, "yyyymmdd") & Replace(Time, ":", "")
  Dim i&
  For i = ActiveDocument.Bookmarks.Count To 1 Step -1 '        
    Dim aMark As Word.BookMark: Set aMark = ActiveDocument.Bookmarks(i)
    Dim bmRange As Word.Range: Set bmRange = aMark.Range
    Dim newName$: newName = pref & "_" & aMark.Name
    
    '    
    If Len(newName) > 40 Then _
      GoTo NEXT_BM
    
    Call contextMap.Add(newName, aMark.Name)
    Call bmRange.Bookmarks.Add(pref & "_" & aMark.Name)
    Call aMark.Delete
NEXT_BM:
  Next i
  
  '     
  Dim newAddr$
  For i = ActiveDocument.Hyperlinks.Count To 1 Step -1
    Dim aLink As Word.Hyperlink: Set aLink = ActiveDocument.Hyperlinks(i)
    Dim linkRange As Word.Range: Set linkRange = ActiveDocument.Range(aLink.Range.Start, aLink.Range.End)
    If Not aLink.Address = "" Or aLink.SubAddress = "" Then _
      GoTo NEXT_LINK
    If Not InCollection(aLink.SubAddress, contextMap) Then _
      GoTo NEXT_LINK
    
    newAddr = contextMap(aLink.SubAddress)
    Call aLink.Delete
    Call linkRange.Hyperlinks.Add(linkRange, "", newAddr)
 
NEXT_LINK:
  Next i
End Sub

Public Sub CCM_ConvertAllShapesToText()
'    
  Dim theDoc As Word.Document: Set theDoc = ActiveDocument
  Dim tRange As Word.Range: Set tRange = theDoc.Range
  
  Dim nShape&: nShape = 1
  Dim theText$
  
  Dim aShape As Word.Shape
  Do While nShape <= theDoc.Shapes.Count  '        
    Set aShape = theDoc.Shapes(nShape)
    If Not aShape.Anchor.InRange(tRange) Then _
      GoTo NEXT_SHAPE
    If aShape.Type <> msoTextBox Then _
      GoTo NEXT_SHAPE
    
    theText = aShape.TextFrame.TextRange.Text
    
    aShape.TextFrame.TextRange.Copy
    tRange.Paragraphs.Add
    Call tRange.Paragraphs.Last.Range.Paste
    
NEXT_SHAPE:
    nShape = nShape + 1
  Loop
  
  Call UserInteraction.ShowMessage(IM_SHAPES_TO_TEXT_OK)
End Sub

Public Sub CC_Convert1252_1251()
'   
  Dim theDoc As Word.Document: Set theDoc = ActiveDocument
  theDoc.ActiveWindow.View.ReadingLayout = False
  
  Dim inputR As Word.Range: Set inputR = theDoc.Application.Selection.Range
  
  Dim wordUI As New API_WordWrapper: Call wordUI.SetDocument(theDoc)
  Call wordUI.PauseUI
  
  Call CSE_ProgressBar.Init("  1252 -> 1251", sHeader:=" ...", maxVal:=inputR.Characters.Count)
  Call CSE_ProgressBar.ShowModeless

  Dim aChr As Word.Range: Set aChr = inputR.Characters.First
  Do While aChr.End < inputR.End
    Dim chrW&: chrW = VBA.AscW(aChr)
    If chrW < 256 And chrW > 127 Then _
      aChr.Text = VBA.Chr(chrW)
    Set aChr = aChr.Next(wdCharacter, 1)
    Call CSE_ProgressBar.IncrementA
  Loop
  
  Call Unload(CSE_ProgressBar)
  Call wordUI.ResumeUI
  Call UserInteraction.ShowMessage(IM_CONVERT_CODEPAGE_OK)
End Sub

' ============
Private Function bilCrossRef(execField As Word.Field)
  If execField.Type <> wdFieldRef Then _
    Exit Function
    
  With execField
    Dim codeStr$: codeStr = .code
    Dim fSlash&: fSlash = InStr(codeStr, "\")
    fSlash = IIf(fSlash = 0, Len(codeStr), fSlash)
    codeStr = Left(codeStr, fSlash - 1) & "\* Lower \h }"
    
    .code.Text = codeStr
    .Update
    
    .result.Italic = True
    .result.Bold = True
  End With
End Function

